<template>
  <div class="app-container">
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['aideviceevent:aideviceevent:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['aideviceevent:aideviceevent:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['aideviceevent:aideviceevent:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['aideviceevent:aideviceevent:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getEventList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="aideviceeventList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="事件类型名称" align="center" prop="eventTypeName" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['aideviceevent:aideviceevent:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['aideviceevent:aideviceevent:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getEventList"
    />

    <!-- 添加或修改AI对应事件对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="事件类型" prop="eventType">
          <el-select v-model="form.eventType" placeholder="请选择事件类型" @change="selectTrigger(form.eventType)">
            <el-option
              v-for="dict in eventOptions "
              :key="dict.id"
              :label="dict.eventTypeName"
              :value="dict.id"
            ></el-option>
          </el-select>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listAideviceevent, getAideviceevent, delAideviceevent, addAideviceevent, updateAideviceevent,selectEventType } from "@/api/centerMonitor/aideviceevent/aideviceevent";

export default {
  name: "Aideviceevent",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // AI对应事件表格数据
      aideviceeventList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      //事件类型选项
      eventOptions: null,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        aideviceType: null,
        deviceCode: null,
        deviceId: null,
        deviceName: null,
        eventType: null,
        eventTypeName: null,
        createName: null,
        updateName: null,
        dataStatus: null,
        deptId: null,
        deptName: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        eventType: [
          { required: true, message: "事件类型不能为空", trigger: "blur" },
        ],
      }
    };
  },
  created() {
    this.getEventList();
    this.getEventOptions();
  },
  props: {
    sonId: null,
    sonCode:null,
    sonName:null,
    sonType:null
  },
  methods: {
    //查询事件类型选项
    getEventOptions() {
      selectEventType().then(response => {
        console.log(response);
        this.eventOptions = response;
      });
    },
    //事件名称赋值
    selectTrigger(val){
      if (val) {
        const that = this;
        this.eventOptions.forEach(function (item,index) {
          if(item.id == val){
            that.form.eventTypeName = item.eventTypeName;
          }
        })
      }
    },
    /** 查询AI对应事件列表 */
    getEventList() {
      this.loading = true;
      this.queryParams.deviceId = this.sonId;
      listAideviceevent(this.queryParams).then(response => {
        this.aideviceeventList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        aideviceType: null,
        deviceCode: null,
        deviceId: null,
        deviceName: null,
        eventType: null,
        eventTypeName: null,
        createBy: null,
        createName: null,
        createTime: null,
        updateBy: null,
        updateName: null,
        updateTime: null,
        dataStatus: "data_status_1",
        deptId: null,
        deptName: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getEventList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.form.aideviceType = this.sonType;
      this.form.deviceCode = this.sonCode;
      this.form.deviceId = this.sonId;
      this.form.deviceName = this.sonName;
      this.open = true;
      this.title = "添加AI对应事件";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getAideviceevent(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改AI对应事件";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateAideviceevent(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getEventList();
            });
          } else {
            addAideviceevent(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getEventList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除数据项？').then(function() {
        return delAideviceevent(ids);
      }).then(() => {
        this.getEventList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('center-monitor/aideviceevent/export', {
        ...this.queryParams
      }, `aideviceevent_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
